#include <cstdio>
#include <climits>
#include <cstdint>
#include <cstring>
#include <cstdlib>

#define coord(x, y)  (x + (y*5001))
#define max(a, b)    ((a>b) ? a : b)
#define min(a, b)    ((a<b) ? a : b)

/*static int abs(int n) {
	if (n < 0)
		return -n;
	else
		return n;
}*/

typedef struct {
	int a;
	int b;
} guard;

guard *guards;

int I, G;


/*
int solve(int a, int b) {
	if (matrix[coord(a, b)]) return 0;
	for (int radius = 1; radius < 5001; radius++) {
		const int left = b - radius;
		const int right = b + radius;
		const int up = a - radius;
		const int down = a + radius;
		
		if (left >= 0)
			for (int x = max(0, up); x < min(5000, down); x++)
				if (matrix[coord(x, left)]) return radius;
		
		if (right < 5001)
			for (int x = max(0, up); x < min(5000, down); x++)
				if (matrix[coord(x, right)]) return radius;

		if (up >= 0)
			for (int y = max(0, left); y < min(5000, right); y++)
				if (matrix[coord(up, y)]) return radius;
		
		if (down < 5001)
			for (int y = max(0, left); y < min(5000, right); y++)
				if (matrix[coord(down, y)]) return radius;
	}
	
	return 5001;
}
*/


/*
static int solve(int a, int b) {
	int result = INT_MAX;
	for (int g = 0; g < G; g++) {
		const int adist = abs(guards[g].a - a);
		const int bdist = abs(guards[g].b - b);
		const int dist = max(adist, bdist);
		result = min(result, dist);
	}
	return result;
}
*/

int cmp_a(const void *a, const void *b) {
	guard *aa = (guard *)a;
	guard *bb = (guard *)b;
	return aa->a - bb->a;
}

int find_closest(int a) {
	int low = 0;
	int high = 5001;
	while (high != low) {
		int half = (high - low)/2 + low;
		if (guards[half].a > a) {
			high = half;
		} else {
			low = half;
		}
	}
	return low;
}

int solve(int a, int b) {
	int low, high, dist_a, dist_b, idx;
	low = high = find_closest(a);
	
	int low_b = 50000;
	do {
		int dist_l = abs(guards[low].a - a);
		int dist_h = abs(guards[high].a - a);
		
		if (dist_l < dist_h) {
			dist_a = dist_l;
			idx = low--;
		} else {
			dist_a = dist_h;
			idx = high++;
		}
		
		dist_b = abs(guards[idx].b - b);
		low_b = min(low_b, dist_b);
	} while (dist_a < dist_b);
	
	return min(dist_a, low_b);
}

int main() {
	int a,b;
	
	
	scanf("%i %i\n", &G, &I);
	guards = new guard[G];
	
	for (int i = 0; i < G; i++) {
		scanf("%i %i\n", &a, &b);
		guards[i].a = a;
		guards[i].b = b;
	}
	
	qsort(guards, G, sizeof(guard), &cmp_a);
		
	for(int i = 0; i < I; i++){
		scanf("%i %i\n", &a, &b);
		int result = solve(a,b);
		printf("%u\n", result);
	}
}
